/**
 * generated by Xtext 2.27.0
 */
package tdt4250.ra.generator;

import com.google.common.collect.Iterators;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import tdt4250.ra.Department;
import tdt4250.ra.Person;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class RaDSL2022Generator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    final Department root = IteratorExtensions.<Department>head(Iterators.<Department>filter(resource.getAllContents(), Department.class));
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<html>");
    _builder.newLine();
    _builder.append("<h1>Allocation for the ");
    String _name = root.getName();
    _builder.append(_name);
    _builder.append("</h1>");
    _builder.newLineIfNotEmpty();
    _builder.append("<ul>");
    _builder.newLine();
    {
      EList<Person> _staff = root.getStaff();
      for(final Person p : _staff) {
        _builder.append("<li>");
        String _name_1 = p.getName();
        _builder.append(_name_1);
        _builder.append("</li>");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("</ul>");
    _builder.newLine();
    _builder.append("</html>");
    _builder.newLine();
    final String textToBeGenerated = _builder.toString();
    String _shortName = root.getShortName();
    String _plus = (_shortName + ".html");
    fsa.generateFile(_plus, textToBeGenerated);
  }
}
